package com.microsoft.trouterclient;

/**
 * Represents a Trouter request. Created after a listener is identified for an incoming server request
 */
public interface ITrouterRequest extends ITrouterHttpMessage {
    /**
     * Gets the part of the url after the service url and the routing path. This will include any query parameters
     * For example, from the URL <public_url>/<agent_name>/v1/getStatus, this returns "/v1/getStatus"
     */
    public String getUrlPathComponent();

    /**
     * Gets the HTTP-like method name used by the caller.
     */
    public String getMethod();
}
