package com.microsoft.trouterclient.registration;

/**
 * Represents a callback for trouter registrar client to acquire authentication token for its requests
 */
public interface ISkypetokenProvider {
    /**
     * Called back whenever Registrar client needs X-Skypetoken auth header value for its next request
     * It is recommended that auth tokens are cached in the upper layer and returned immediately
     *
     * forceRefresh parameter is set to true when Registrar client hits 401 Unauthorized error
     * which may indicate an expired or revoked token so the hint is to ask for new token
     * to be issued instead of returning cached one
     */
    public String getSkypetoken(boolean forceRefresh);
}
