package com.microsoft.trouterclient.registration;

import com.microsoft.trouterclient.ITrouterAuthHeadersProvider;
import com.microsoft.trouterclient.ITrouterAuthHeadersSetter;

/**
 * Adapter of ISkypetokenProvider to ITrouterAuthHeadersProvider
 * For the convenience of using ISkypetokenProvider for both Trouter client and Registration authentication
 */
public class TrouterSkypetokenAuthHeaderProvider implements ITrouterAuthHeadersProvider {
    private ISkypetokenProvider skypetokenProvider;

    public TrouterSkypetokenAuthHeaderProvider(ISkypetokenProvider skypetokenProvider) {
        if (skypetokenProvider == null) {
            throw new IllegalArgumentException("skypetokenProvider is mandatory dependency");
        } else {
            this.skypetokenProvider = skypetokenProvider;
        }
    }

    @Override
    public void getAuthHeaders(boolean forceRefresh, ITrouterAuthHeadersSetter trouterAuthHeadersSetter) {
        final String authHeader = "X-Skypetoken: " + skypetokenProvider.getSkypetoken(forceRefresh);
        trouterAuthHeadersSetter.set(authHeader);
    }
}
